<?php
 /**************************************************************************\
 * phpGroupWare - correspondence                                            *
 * http://www.phpgroupware.org                                              *
 * -----------------------------------------------                          *
 *  This program is free software; you can redistribute it and/or modify it *
 *  under the terms of the GNU General Public License as published by the   *
 *  Free Software Foundation; either version 2 of the License, or (at your  *
 *  option) any later version.                                              *
 \**************************************************************************/

/* $Id: class.uicorrespondence.inc.php,v 1.21 2006-07-26 12:03:34 andre Exp $ */

class uicorrespondence
{
  var $bo;

  var $cat;
  var $status;

  var $types;
  var $grants;

  var $nextmatchs;

  var $public_functions = array(
				'add'  => True,
				'edit' => True,
				'view' => True,
				'delete' => True,
				'forward' => True,
				'comment' => True,
				'archive' => True,
				'listview' => True,
				'searchview' => True,
				'search' => True,
				'header' => True
				);

  function uicorrespondence()
  {
    $this->bo = CreateObject('correspondence.bocorrespondence',1);

    list(,,$fkt) = explode('.',$GLOBALS['phpgw_info']['menuaction']);
    if ($fkt == 'listview' || $fkt == 'view') {
      $this->bo->return_to = $GLOBALS['phpgw_info']['menuaction'];
    }
    $this->bo->save_sessiondata();
    $this->cat = &$this->bo->cat;
    $this->status = &$this->bo->status;

    $this->nextmatchs = CreateObject('phpgwapi.nextmatchs');
    
    $this->theme = $GLOBALS['phpgw_info']['theme'];

    $this->types = CreateObject('correspondence.types');

    $this->grants = $GLOBALS['phpgw']->acl->get_grants('correspondence');
  }

  function forward()
  {  
    if(isset($_GET['doc_id'])) {
      $doc_id = $_GET['doc_id'];
    }
    else {
      $this->listview();
      return False;
    }

    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);

    $GLOBALS['phpgw_info']['flags']['app_header'] = lang('history - forward');

    $GLOBALS['phpgw']->common->phpgw_header();

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file(array('t_hist' => 'history.tpl'));

    $tpl->set_block('t_hist','form','form');
    $tpl->set_block('t_hist','row_archive','V_row_archive');
    $tpl->set_block('t_hist','row_forward','V_row_forward');
    $tpl->set_block('t_hist','form_button','form_button');

    // Participants
    $accounts = $GLOBALS['phpgw']->acl->get_ids_for_location('run',1,'correspondence');
    $users = Array();
    for($i=0;$i<count($accounts);$i++) {
      $user = $accounts[$i];
      if(!isset($users[$user])) {
	$users[$user] = $GLOBALS['phpgw']->common->grab_owner_name($user);
        if($GLOBALS['phpgw']->accounts->get_type($user) == 'g') {
          $group_members = $GLOBALS['phpgw']->acl->get_ids_for_location($user,1,'phpgw_group');
          if($group_members != False) {
            for($j=0;$j<count($group_members);$j++) {
              if(!isset($users[$group_members[$j]])) {
                $users[$group_members[$j]] = $GLOBALS['phpgw']->common->grab_owner_name($group_members[$j]);
              }
            }
          }
        }
      }
    }
    
    $num_users = count($users);
    
    if ($num_users > 5) {
      $size = 5;
    }
    else {
      $size = $num_users;
    }
    $str = '';
    @asort($users);
    @reset($users);
    while ($user = each($users)) {
      if($GLOBALS['phpgw']->accounts->exists($user[0]) || $GLOBALS['phpgw']->accounts->get_type($user[0]) == 'g') {
        $str .= '    <option value="'.$user[0].'">('.$GLOBALS['phpgw']->accounts->get_type($user[0]).') '.$user[1].'</option>'."\n";
      }
    }

    $watchers = '<select name="watchers[]" multiple size="'.$size.'">'."\n".$str.'   </select>';

    $vars = Array(
		  'bg_color'        => $this->theme['th_bg'],
		  'action_url'      => $GLOBALS['phpgw']->link('/index.php',Array('menuaction'=>'correspondence.bocorrespondence.add_history')),
		  'tr_color1'       => $this->theme['row_on'],
		  'tr_color2'       => $this->theme['row_off'],
		  'lang_notes'      => lang('notes'),
		  'lang_forwardto'  => lang('forward by e-mail to'),
		  'hist_notes'      => '<textarea name="notes" rows="5" cols="40" wrap="virtual" maxlength="2048"></textarea>',
		  'hist_forwardto'  => $watchers,
		  'ctrl_hint' => '<i>'.lang('hint: hold down CTRL key for multiple choices').'</i>',
		  'hist_alert'      => '<input type="checkbox" name="notify" value="yes" checked>',
		  'submit_button'   => lang('forward'),
		  'common_hidden' => '<input type="hidden" name="doc_id" value="'.$doc_id.'">'
		  );

    $tpl->set_var($vars);

    $forward_section = $tpl->fp('out','row_forward');
    $tpl->set_var('V_row_forward',$forward_section);

    $tpl->set_var('V_row_archive','');

    // other actions
    $cancel_button = '';

    if ($this->bo->return_to) {
      $var = Array(
	   'action_url_button'     => $GLOBALS['phpgw']->link('/index.php',
			      array(
				    'menuaction' => $this->bo->return_to,
				    'doc_id' => $doc_id
				    )),
	   'action_text_button'    => lang('cancel')
	   );
      $tpl->set_var($var);
      $cancel_button = $tpl->fp('out','form_button');
    }
    $tpl->set_var('cancel_button',$cancel_button);
    
    $tpl->pparse('out','form');
  }

  function comment()
  {
    if(isset($_GET['doc_id'])) {
      $doc_id = $_GET['doc_id'];
    }
    else {
      $this->listview();
      return False;
    }

    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);

    $GLOBALS['phpgw_info']['flags']['app_header'] = lang('history - add comment');

    $GLOBALS['phpgw']->common->phpgw_header();

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file(array('t_hist' => 'history.tpl'));

    $tpl->set_block('t_hist','form','form');
    $tpl->set_block('t_hist','row_archive','V_row_archive');
    $tpl->set_block('t_hist','row_forward','V_row_forward');
    $tpl->set_block('t_hist','form_button','form_button');

    $vars = Array(
		  'bg_color'        => $this->theme['th_bg'],
		  'action_url'      => $GLOBALS['phpgw']->link('/index.php',Array('menuaction'=>'correspondence.bocorrespondence.add_history')),
		  'tr_color1'       => $this->theme['row_on'],
		  'tr_color2'       => $this->theme['row_off'],
		  'lang_notes'      => lang('notes'),
		  'hist_notes'      => '<textarea name="notes" rows="5" cols="40" wrap="virtual" maxlength="2048"></textarea>',
		  'submit_button' => lang('post comment'),
		  'common_hidden' => '<input type="hidden" name="doc_id" value="'.$doc_id.'">'
		  );

    $tpl->set_var($vars);

    $tpl->set_var('V_row_forward','');
    $tpl->set_var('V_row_archive','');

    // other actions
    $cancel_button = '';

    if ($this->bo->return_to) {
      $var = Array(
	   'action_url_button'     => $GLOBALS['phpgw']->link('/index.php',
			      array(
				    'menuaction' => $this->bo->return_to,
				    'doc_id' => $doc_id
				    )),
	   'action_text_button'    => lang('cancel')
	   );
      $tpl->set_var($var);
      $cancel_button = $tpl->fp('out','form_button');
    }
    $tpl->set_var('cancel_button',$cancel_button);
    
    $tpl->pparse('out','form');
  }

  function archive()
  {
    if(isset($_GET['doc_id'])) {
      $doc_id = $_GET['doc_id'];
    }
    else {
      $this->listview();
      return False;
    }

    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);

    $GLOBALS['phpgw_info']['flags']['app_header'] = lang('history - archive');

    $GLOBALS['phpgw']->common->phpgw_header();

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file(array('t_hist' => 'history.tpl'));

    $tpl->set_block('t_hist','form','form');
    $tpl->set_block('t_hist','row_archive','V_row_archive');
    $tpl->set_block('t_hist','row_forward','V_row_forward');
    $tpl->set_block('t_hist','form_button','form_button');

    $vars = Array(
		  'bg_color'        => $this->theme['th_bg'],
		  'action_url'      => $GLOBALS['phpgw']->link('/index.php',Array('menuaction'=>'correspondence.bocorrespondence.add_history')),
		  'tr_color1'       => $this->theme['row_on'],
		  'tr_color2'       => $this->theme['row_off'],
		  'lang_notes'      => lang('notes'),
		  'lang_archiveid'  => lang('archive protocol'),
		  'hist_notes'      => '<textarea name="notes" rows="5" cols="40" wrap="virtual" maxlength="2048"></textarea>',
		  'hist_archiveid'  => '<input name="archiveid" size="10" maxlength="10">',
		  'submit_button' => lang('archive'),
		  'common_hidden' => '<input type="hidden" name="doc_id" value="'.$doc_id.'">'
		  );

    $tpl->set_var($vars);

    $archive_section = $tpl->fp('out','row_archive');
    $tpl->set_var('V_row_archive',$archive_section);

    $tpl->set_var('V_row_forward','');

    // other actions
    $cancel_button = '';

    if ($this->bo->return_to) {
      $var = Array(
	   'action_url_button'     => $GLOBALS['phpgw']->link('/index.php',
			      array(
				    'menuaction' => $this->bo->return_to,
				    'doc_id' => $doc_id
				    )),
	   'action_text_button'    => lang('cancel')
	   );
      $tpl->set_var($var);
      $cancel_button = $tpl->fp('out','form_button');
    }
    $tpl->set_var('cancel_button',$cancel_button);
    
    $tpl->pparse('out','form');
  }

  function date2string($_date)
  {
    $dateformat = $GLOBALS['phpgw_info']['user']['preferences']['common']['dateformat'];
    $d = getdate($_date);
    $datestring = date($dateformat,
		       mktime(0,0,0,$d['mon'],$d['mday'],$d['year']));

    return $datestring;
  }

  function view()
  {
    // functions for easy attachment of docs
    $GLOBALS['phpgw_info']['flags']['java_script'] .= "\n"
      . '<script type="text/javascript" src="'
      . $GLOBALS['phpgw']->link('/correspondence/js/attach.js')
      ."\">\n</script>\n";

    if(isset($_GET['doc_id'])) {
      $doc_id = $_GET['doc_id'];
    }
    else {
      $this->listview();
      return False;
    }

    $userData = $this->bo->read_repository($doc_id);
    
    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);

    $GLOBALS['phpgw_info']['flags']['app_header'] = lang('correspondence - view');

    $GLOBALS['phpgw']->common->phpgw_header();

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file(array('t_view' => 'view.tpl'));

    $tpl->set_block('t_view','view','view');
    $tpl->set_block('t_view','row_attachment','row_attachment');
    $tpl->set_block('t_view','row_history','row_history');
    $tpl->set_block('t_view','form_button','form_button');
    $tpl->set_block('t_view','image_attach','image_attach');

    switch($userData['priority']) {
    case 0:
      $priority = lang('low');
      $prio_color = '';
      break;
    case 1:
      $priority = lang('normal');
      $prio_color = '#FFFFCC';
      break;
    case 2:
      $priority = lang('high');
      $prio_color = '#FF9999';
      break;
    default:
      $priority = '&nbsp;';
      $prio_color = '';
    }

    
    switch($userData['direction']) {
    case 'R':
      $direction = lang('input');
      break;
    case 'S':
      $direction = lang('output');
      break;
    default:
      $direction = '&nbsp;';
    }

    // categories in a list
    $selected = explode(',',$userData['category']);
    $sel_count = count($selected);

    if ($sel_count == 0 || !$userData['category']) {
      $cat_str = '&nbsp;';
    }
    elseif ($sel_count == 1) {
      $cat = $this->cat->return_single($selected[0]);
      $cat_str = $cat[0]['name'];
    }
    else {
      $cat_array = array();
      while (list(,$sel) = each($selected)) {
	$cat = $this->cat->return_single($sel);
	array_push($cat_array,$cat[0]['name']);
      }

      $cat_str = implode(', ',$cat_array);
    }

    // Participants
    if ($userData['watchers'] == NULL) {
      $watchers_str = '--';
    } else {
      $watchers = explode(',',$userData['watchers']);
      $w_count = count($watchers);
      if ($w_count > 0) {
	$names = array();
	for($i=0;$i<$w_count;$i++) {
	  $user = $watchers[$i];
	  $names[] = $GLOBALS['phpgw']->common->grab_owner_name($user);
	}
	
	$watchers_str = implode(', ',$names);
      }
    }

    // status
    $today = time();
    $near = $today + ($this->bo->prefs['correspondence']['near_days']*24*3600);

    $status = $userData['status'];
    if ($userData['status'] == 'pending') {
      if ($userData['deadline'] < $today) {
	$status = 'expired';
      }
      elseif ($userData['deadline'] < $near) {
	$status_color = $this->status->colors['near'];
      }
    }
    if (!isset($status_color)) {
      $status_color = $this->status->colors[$status];
    }

    // general fields
    $vars = Array(
		  'bg_color' => $this->theme['th_bg'],
		  'tr_color1' => $this->theme['row_on'],
		  'tr_color2' => $this->theme['row_off'],
		  'th_bg'    => $this->theme['th_bg'],
		  'lang_owner' => lang('responsible'),
		  'lang_date' => lang('insertion'),
		  'lang_deadline' => lang('deadline'),
		  'lang_subject' => lang('subject'),
		  'lang_protocol' => lang('protocol number'),
		  'lang_description' => lang('description'),
		  'lang_category' => lang('category'),
		  'lang_type' => lang('type'),
		  'lang_to' => lang('to'),
		  'lang_from' => lang('from'),
		  'lang_status' => lang('status'),
		  'lang_priority' => lang('priority'),
		  'lang_attachments' => lang('attachments/references'),
		  'lang_history' => lang('history'),
		  'lang_watchers' => lang('participants'),
		  'lang_generalinfo' => lang('general info'),
		  'lang_archiving' => lang('archive number'),
		  'lang_name' => lang('name'),
		  'lang_size' => lang('size'),
		  'lang_action' => lang('open'),
		  'lang_user' => lang('user'),
		  'lang_forwardto' => lang('forwarded to'),
		  'doc_from' => (!$userData['doc_from']?'&nbsp':$userData['doc_from']),
		  'doc_to' => (!$userData['doc_to']?'&nbsp':$userData['doc_to']),
		  'doc_date'  => $this->date2string($userData['startdate']),
		  'doc_deadline'  => $this->date2string($userData['deadline']),
		  'doc_type'  => $this->types->id2name($userData['doc_type']),
		  'doc_priority' => $priority,
		  'doc_protocol' => $userData['protocol'],
		  'archiveid' => $userData['id_archive'],
		  'doc_subject'  => $userData['subject'],
		  'doc_description'  => $userData['description'],
		  'doc_status'  => lang($status),
		  'doc_direction' => '<strong>'.$direction.'</strong>',
		  'doc_category' => $cat_str,
		  'doc_owner' => $GLOBALS['phpgw']->common->grab_owner_name($userData['owner']),
		  'status_color' => $status_color,
		  'prio_color' => $prio_color,
		  'doc_watchers' => $watchers_str
		  );

    $tpl->set_var($vars);

    // attachments/references
    // only owner/participants can manipulate attachs
    $current_user = intval($GLOBALS['phpgw_info']['user']['account_id']);

    if ($userData['watchers'] != NULL) {
      $watchers = explode(',',$userData['watchers']);
      $w_count = count($watchers);
      if ($w_count > 0) {
	$users = array();
	for($i=0;$i<$w_count;$i++) {
	  $users[] = $watchers[$i];
	}
      }
    }
    $users[] = $userData['owner'];

    if (in_array($current_user,$users)) {
      $attachfile_js_link = $GLOBALS['phpgw']->link('/index.php',
		    array(
			  'menuaction' => 'correspondence.uiattach.attach',
			  'doc_id' => $doc_id
			  ));
      $tpl->set_var('attachfile_js_onclick','attach_window(\''.$attachfile_js_link.'\')');
      $tpl->set_var('att_button_img',$GLOBALS['phpgw']->common->image('correspondence','add-attachment-16'));
      $tpl->set_var('lang_attach_file',lang('attach file'));
      $tpl->parse('img_attach','image_attach',True);
    }
    else {
      $tpl->set_var('img_attach','');
    }
    
    $upload_dir = $GLOBALS['phpgw_info']['server']['files_dir'].SEP.'correspondence'.SEP.$doc_id;
    $attach_info = $this->bo->get_attachments_list($doc_id);
    if (count($attach_info) == 0) {
      $vars = Array (
		     'tr_color' => $this->theme['row_on'],
		     'file_name' => '&nbsp;',
		     'file_size' => '&nbsp;',
		     );
      $tpl->set_var($vars);
      $tpl->parse('rows_att','row_attachment',True);
    }
    else {
      while (list(,$att) = each($attach_info)) {
	$this->nextmatchs->template_alternate_row_color($tpl);
	
	// get filesize in kb, but do not tell user a file is 0kb,
	// because it is probably closer to 1kb
	$real_file_size = ((int) ($att['size']/1024));
	if ($real_file_size < 1) {
	  $real_file_size = 1;
	}
	
	$file_url = $GLOBALS['phpgw']->link('/index.php',
		     Array('menuaction' => 'correspondence.bocorrespondence.open_attachment',
			   'attach_id' => $att['attach_id']
			   ));

	$vars = array(
		     'file_name' => '<a href="'.$file_url.'">'.$att['name'].'</a>',
		     'file_size' => $real_file_size.'k'
		     );
	
	$tpl->set_var($vars);
	$tpl->parse('rows_att','row_attachment',True);
      }
    }    

    // document history
    $hist_info = $this->bo->get_history_list($doc_id);
    if (!count($hist_info)) {
      $vars = Array (
		     'tr_color' => $this->theme['row_on'],
		     'date' => '&nbsp;',
		     'description' => '&nbsp;',
		     'user' => '&nbsp;',
		     'forwardto' => '&nbsp;'
		     );
      $tpl->set_var($vars);
      $tpl->parse('rows_hist','row_history',True);
    }
    else {
      while (list(,$hist) = each($hist_info)) {

	// many user may have received the forwarding
	if ($hist['fw_user'] == 0) {
	  $forward_str = '--';
	} else {
	  $forward = explode(',',$hist['fw_user']);
	  $f_count = count($forward);
	  $names = array();
	  for($i=0;$i<$f_count;$i++) {
	    $user = $forward[$i];
	    $names[] = $GLOBALS['phpgw']->common->grab_owner_name($user);
	  }
	  $forward_str = implode(', ',$names);
	}

	// user responsible for forwarding the document
	if ($hist['user'] != 0) {
	  $user_name = $GLOBALS['phpgw']->common->grab_owner_name($hist['user']);
	} else {
	  $user_name ='--';
	}

	$this->nextmatchs->template_alternate_row_color($tpl);
	
	$vars = array(
		      'date' => $this->date2string($hist['date']),
		      'description' => $hist['notes'],
		      'forwardto' => $forward_str,
		      'user' => $user_name,
		     );
	
	$tpl->set_var($vars);
	
	$tpl->parse('rows_hist','row_history',True);
      }
    }    

    // actions
    $var = Array(
	 'action_url'   => $GLOBALS['phpgw']->link('/index.php',
			     Array('menuaction' => 'correspondence.uicorrespondence.forward',
				   'doc_id' => $doc_id )),
	 'action_text'  => lang('forward')
	 );
    $tpl->set_var($var);
    $button = $tpl->fp('out','form_button');
    $tpl->set_var('btn_forward',$button);
    
    $var = Array(
	 'action_url'   => $GLOBALS['phpgw']->link('/index.php',
			     Array('menuaction' => 'correspondence.uicorrespondence.comment',
				   'doc_id' => $doc_id )),
	 'action_text'  => lang('comment')
	 );
    $tpl->set_var($var);
    $button = $tpl->fp('out','form_button');
    $tpl->set_var('btn_comment',$button);

    // normally, only the owner can close correspondence
    if ($this->bo->check_perms($this->grants[$userData['owner']],PHPGW_ACL_EDIT)) {
      $var = Array(
	   'action_url'   => $GLOBALS['phpgw']->link('/index.php',
	     Array('menuaction' => 'correspondence.uicorrespondence.archive',
		   'doc_id' => $doc_id )),
	   'action_text'  => lang('archive')
	   );
      $tpl->set_var($var);
      $button = $tpl->fp('out','form_button');
      $tpl->set_var('btn_archive',$button);
    }
    else {
      $tpl->set_var('btn_archive','');
    }

    $tpl->pparse('out','view');
  }

  function add()
  {
    $this->create_edit_document(0);
  }

  function edit()
  {
    if(isset($_GET['doc_id'])) {
      $doc_id = $_GET['doc_id'];
    }
    else {
      $doc_id = 0;
    }
    
    $this->create_edit_document($doc_id);
  }
  
  function create_edit_document($doc_id)
  {
    // before headers, because is javascript
    $jscal = CreateObject('phpgwapi.jscalendar');

    // functions for easy attachment of docs
    $GLOBALS['phpgw_info']['flags']['java_script'] .= "\n"
      . '<script type="text/javascript" src="'
      . $GLOBALS['phpgw']->link('/correspondence/js/attach.js')
      ."\">\n</script>\n";

    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);

    $GLOBALS['phpgw_info']['flags']['app_header'] = $doc_id?lang('correspondence - edit'):lang('correspondence - add');

    $GLOBALS['phpgw']->common->phpgw_header();

    if($doc_id) {
      $userData = $this->bo->read_repository($doc_id);

      $check_cats = explode(',',$userData['category']);
      $check_types = $userData['doc_type'];
      $datestart = $userData['startdate'];
      $deadline = $userData['deadline'];
    }
    else {
      // create empty document, with status 'pending'
      $userData = Array();
      $userData['status'] = 'pending';

      $check_cats[] = 0;
      $check_types[] = 0;

      $datestart = time();
      $deadline = $datestart+($this->bo->prefs['correspondence']['default_deadline']*24*3600);
    }

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file(array('edit_t' => 'edit.tpl'));

    $tpl->set_block('edit_t','form','form');
    $tpl->set_block('edit_t','form_button','form_button');
    $tpl->set_block('edit_t','B_attachments','V_attachments');

    if ($doc_id > 0) {
      $hidden = '<input type="hidden" name="doc_id" value="'.$doc_id.'">';
    } else {
      $tmp_doc_id = rand(1,1000);
      $hidden = '<input type="hidden" name="tmp_doc_id" value="'.$tmp_doc_id.'">';
    }

    // Participants
    $selected = $userData['watchers'];
    if (!is_array($selected)) {
      $selected = explode(',',$selected);
    }

    $accounts = $GLOBALS['phpgw']->acl->get_ids_for_location('run',1,'correspondence');
    $users = Array();
    for($i=0;$i<count($accounts);$i++) {
      $user = $accounts[$i];
      if(!isset($users[$user])) {
	$users[$user] = $GLOBALS['phpgw']->common->grab_owner_name($user);
        if($GLOBALS['phpgw']->accounts->get_type($user) == 'g') {
          $group_members = $GLOBALS['phpgw']->acl->get_ids_for_location($user,1,'phpgw_group');
          if($group_members != False) {
            for($j=0;$j<count($group_members);$j++) {
              if(!isset($users[$group_members[$j]])) {
                $users[$group_members[$j]] = $GLOBALS['phpgw']->common->grab_owner_name($group_members[$j]);
              }
            }
          }
        }
      }
    }
    
    $num_users = count($users);
    
    if ($num_users > 5) {
      $size = 5;
    }
    else {
      $size = $num_users;
    }
    $str = '';
    @asort($users);
    @reset($users);
    while ($user = each($users)) {
      if($GLOBALS['phpgw']->accounts->exists($user[0]) || $GLOBALS['phpgw']->accounts->get_type($user[0]) == 'g') {
        if (in_array($user[0],$selected)) {
          $str .= '    <option value="'.$user[0].'" selected="selected">('.$GLOBALS['phpgw']->accounts->get_type($user[0]).') '.$user[1].'</option>'."\n";
        } else {
          $str .= '    <option value="'.$user[0].'">('.$GLOBALS['phpgw']->accounts->get_type($user[0]).') '.$user[1].'</option>'."\n";
        }
      }
    }

    $watchers = '<select name="watchers[]" multiple size="'.$size.'">'."\n".$str.'   </select>';

    if ($doc_id > 0) {
      $direction = '<input type="radio" name="inout" value="R"'.($userData['direction'] == 'R'?' checked':'').'>'.lang('input')."\n" . '<input type="radio" name="inout" value="S"'.($userData['direction'] == 'S'?' checked':'').'>'.lang('output')."\n";
      $priority = '<input type="radio" name="priority" value="0"'.($userData['priority'] == '0'?' checked':'').'>'.lang('low')."\n" . '<input type="radio" name="priority" value="1"'.($userData['priority'] == '1'?' checked':'').'>'.lang('normal')."\n" . '<input type="radio" name="priority" value="2"'.($userData['priority'] == '2'?' checked':'').'>'.lang('high')."\n";
    }
    else {
      $direction = '<input type="radio" name="inout" value="R" checked>'.lang('input')."\n" . '<input type="radio" name="inout" value="S">'.lang('output')."\n";
      $priority = '<input type="radio" name="priority" value="0" checked>'.lang('low')."\n" . '<input type="radio" name="priority" value="1">'.lang('normal')."\n" . '<input type="radio" name="priority" value="2">'.lang('high')."\n";
    }

    // general fields
    $vars = Array(
		  'bg_color' => $this->theme['th_bg'],
		  'action_url' => $GLOBALS['phpgw']->link('/index.php',Array('menuaction'=>'correspondence.bocorrespondence.update')),
		  'errormsg'  => ($param['cd']?$GLOBALS['phpgw']->common->check_code($param['cd']):''),    
		  'tr_color1' => $this->theme['row_on'],
		  'tr_color2' => $this->theme['row_off'],
		  'lang_date' => lang('insertion'),
		  'lang_deadline' => lang('deadline'),
		  'lang_subject' => lang('subject'),
		  'lang_protocol' => lang('protocol number'),
		  'lang_description' => lang('description'),
		  'lang_category' => lang('category'),
		  'lang_type' => lang('type'),
		  'lang_to' => lang('to'),
		  'lang_status' => lang('status'),
		  'lang_priority' => lang('priority'),
		  'lang_attachments' => lang('attachments/references'),
		  'lang_direction' => lang('sent/received'),
		  'lang_watchers' => lang('participants'),
		  'category' => '<select name="categories[]" multiple size="4">'.$this->cat->formated_list('select','all',$check_cats,True).'</select>',
		  'ctrl_hint' => '<i>'.lang('hint: hold down CTRL key for multiple choices').'</i>',
		  'doc_type' => '<select name="types[]">'.$this->types->formated_list($check_types).'</select>',
		  'lang_from' => lang('from'),
		  'doc_description' => '<textarea name="description" rows="5" cols="40" wrap="virtual" maxlength="2048">'.$userData['description'].'</textarea>',
		  'doc_subject'  => '<input value="'.$userData['subject'].'" name="subject" size="45" maxlength="80">',
		  'doc_protocol' => '<input name="protocol" size="10" maxlength="10" value="'.$userData['protocol'].'">',
		  'doc_date' => $jscal->input('datestart[str]',$datestart),
		  'doc_deadline' => $jscal->input('deadline[str]',$deadline),
		  'doc_to' => '<input name="to" size="30" maxlength="50" value="'.$userData['doc_to'].'">',
		  'doc_from' => '<input name="from" size="30" maxlength="50" value="'.$userData['doc_from'].'">',
		  'doc_direction' => $direction,
		  'doc_priority' => $priority,
		  'doc_watchers' => $watchers,
		  'submit_button' => lang('save'),
		  'common_hidden' => $hidden
		  );

    $tpl->set_var($vars);  

    // attachments/references
    if ($doc_id > 0) {
      $attachfile_js_link = $GLOBALS['phpgw']->link('/index.php',
		  array(
			'menuaction' => 'correspondence.uiattach.attach',
			'doc_id' => $doc_id
			));
      $tpl->set_var('attachfile_js_onclick','attach_window(\''.$attachfile_js_link.'\')');
      $tpl->set_var('att_button_img',$GLOBALS['phpgw']->common->image('correspondence','add-attachment-16'));
      $tpl->set_var('lang_attach_file',lang('attach file'));
      
      $attach_info = $this->bo->get_attachments_names($doc_id);
      if (count($attach_info) == 0) {
	$tpl->set_var('attachments','');
      }
      else {
	$str = implode(', ', $attach_info);
	$tpl->set_var('attachments',$str);
      }
      
      $attach_section = $tpl->fp('out','B_attachments');
      $tpl->set_var('V_attachments',$attach_section);
    }
    else {
      $attachfile_js_link = $GLOBALS['phpgw']->link('/index.php',
		  array(
			'menuaction' => 'correspondence.uiattach.attach',
			'tmp_doc_id' => $tmp_doc_id
			));
      
      $tpl->set_var('attachfile_js_onclick',
		    'attach_window(\''.$attachfile_js_link.'\')');
      $tpl->set_var('att_button_img',
	    $GLOBALS['phpgw']->common->image('correspondence',
					     'add-attachment-16'));
      $tpl->set_var('lang_attach_file',lang('attach file'));    
      $tpl->set_var('attachments','');

      $attach_section = $tpl->fp('out','B_attachments');
      $tpl->set_var('V_attachments',$attach_section);
    }

    // other actions
    $delete_button = $cancel_button = '';
    if ($this->bo->check_perms($this->grants[$userData['owner']],PHPGW_ACL_DELETE) || $values['owner'] == $GLOBALS['phpgw_info']['user']['account_id']) {
      if ($doc_id > 0) {
	$var = Array(
	     'action_url_button'     => $GLOBALS['phpgw']->link('/index.php',
		Array('menuaction' => 'correspondence.uicorrespondence.delete',
		      'doc_id' => $doc_id )),
	     'action_text_button'    => lang('delete'),
	     'action_confirm_button' => '',
	     'action_extra_field'    => ''
	     );
	$tpl->set_var($var);
	$delete_button = $tpl->fp('out','form_button');
      }
    }
    $tpl->set_var('delete_button',$delete_button);

    if ($this->bo->return_to) {
      $var = Array(
	   'action_url_button'     => $GLOBALS['phpgw']->link('/index.php','menuaction='.$this->bo->return_to),
	   'action_text_button'    => lang('cancel'),
	   'action_confirm_button' => '',
	   'action_extra_field'    => ''
	   );
      $tpl->set_var($var);
      $cancel_button = $tpl->fp('out','form_button');
    }
    $tpl->set_var('cancel_button',$cancel_button);
       
    $tpl->pparse('out','form');
  }

  function delete()
  {
    if ($_POST['no'] || $_POST['yes'] || !@isset($_GET['doc_id']) || !@$_GET['doc_id']) {
      if ($_POST['yes']) {
	$this->bo->delete($_POST['doc_id']);
      }

      if ($this->bo->return_to)	{
	Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction='.$this->bo->return_to));
      }
      else {
	Header('Location: '.$GLOBALS['phpgw']->link('/index.php','menuaction=correspondence.uicorrespondence.listview'));
      }
      $GLOBALS['phpgw']->common->phpgw_exit();
    }

    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
    $GLOBALS['phpgw']->common->phpgw_header();

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file('del_t', 'delete.tpl');

    $tpl->set_block('del_t','form','form');
    $tpl->set_block('del_t','message_row','message_row');
    
    $tpl->set_var('message_display',
		  lang('are you sure you want to delete this correspondence?'));
    $tpl->parse('messages','message_row');

    $var = Array(
		 'form_action' => $GLOBALS['phpgw']->link('/index.php','menuaction=correspondence.uicorrespondence.delete'),
		 'hidden_vars' => '<input type="hidden" name="doc_id" value="'.$_GET['doc_id'].'">',
		 'yes'         => lang('yes'),
		 'no'          => lang('no')
		 );
    $tpl->set_var($var);
    $tpl->pparse('phpgw_body','form');
  }

  function row_action($action,$doc_id)
  {
    return '<a href="'.$GLOBALS['phpgw']->link('/index.php',
       Array('menuaction' => 'correspondence.uicorrespondence.'.$action,
	     'doc_id' => $doc_id ))
       .'"> '.lang($action).' </a>';
  }

  function listview()
  {
    if(isset($_POST['query'])) {
      $GLOBALS['query'] = $_POST['query'];
    }
    
    if(isset($_POST['start'])) {
      $start = intval($_POST['start']);
    }
    else {
      $start = 0;
    }
    
    if(isset($_GET['order'])) {
      $order = $_GET['order'];
    }
    else {
      $order = $this->bo->prefs['correspondence']['defaultsort'];
    }

    if(isset($_GET['sort'])) {
      $sort = $_GET['sort'];
    }
    else {
      $sort = $this->bo->prefs['correspondence']['defaultsortdir'];
    }

    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
    unset($GLOBALS['phpgw_info']['flags']['noappheader']);
    unset($GLOBALS['phpgw_info']['flags']['noappfooter']);

    $GLOBALS['phpgw']->common->phpgw_header();

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file(array('docs_t' => 'list.tpl'));

    $tpl->set_block('docs_t','list','list');
    $tpl->set_block('docs_t','row','row');
    $tpl->set_block('docs_t','row_empty','row_empty');
    
    $docs_info = $this->bo->get_list($start,$sort,$order,$GLOBALS['query']);
    $total = $this->bo->total;
    
    $url = $GLOBALS['phpgw']->link('/index.php','menuaction=correspondence.uicorrespondence.listview');

    $var = Array(
		 'bg_color' => $this->theme['bg_color'],
		 'th_bg'    => $this->theme['th_bg'],
		 'left_next_matchs'   => $this->nextmatchs->left($url,$start,$total,'menuaction=correspondence.uicorrespondence.listview'),
		 'lang_documents' => $total?lang('%1 - %2 of %3 correspondences',$start+1,$start+count($docs_info),$total):'&nbsp;',
		 'right_next_matchs'  => $this->nextmatchs->right($url,$start,$total,'menuaction=correspondence.uicorrespondence.listview'),
		 'lang_edit'    => lang('edit'),
		 'actionurl'    => $GLOBALS['phpgw']->link('/index.php','menuaction=correspondence.uicorrespondence.add'),
		 'docs_url' => $url,
		 'lang_search'  => lang('search'),
		 'lang_owner' => lang('responsible'),
		 'lang_protocol' => $this->nextmatchs->show_sort_order($sort,'id_protocol',$order,$url,lang('protocol number')),
		 'lang_subject' => $this->nextmatchs->show_sort_order($sort,'subject',$order,$url,lang('subject')),
		 'lang_date' => $this->nextmatchs->show_sort_order($sort,'startdate',$order,$url,lang('insertion')),
		 'lang_deadline' => $this->nextmatchs->show_sort_order($sort,'deadline',$order,$url,lang('deadline')),
		 'lang_from' => $this->nextmatchs->show_sort_order($sort,'doc_from',$order,$url,lang('from')),
		 'lang_to' => $this->nextmatchs->show_sort_order($sort,'doc_to',$order,$url,lang('to')),
		 'lang_status' => lang('status'),
		 'lang_priority' => $this->nextmatchs->show_sort_order($sort,'priority',$order,$url,lang('priority')),
		 'lang_lastuser' => lang('last user'),
		 'lang_edit'    => lang('edit'),
		 'input_add' => '<input type="submit" value="' . lang('add') . '">',
		 'input_search' => lang('search') . '&nbsp;<input type="text" name="query" value='.$GLOBALS['query'].'>'
		 );

    $tpl->set_var($var);

    if (!count($docs_info) || !$total) {
      $tpl->set_var('message',lang('no correspondences'));
      $tpl->parse('rows','row_empty',True);
    }
    else {
      $today = time();
      $near = $today + ($this->bo->prefs['correspondence']['near_days']*24*3600);

      while (list($null,$doc) = each($docs_info)) {
	$this->nextmatchs->template_alternate_row_color($tpl);
	
	$type = $this->types->id2name($doc['doc_type']);

	// status
	$status = $doc['status'];
	$status_color = $this->status->colors[$status];
	if ($status == 'pending') {
	  if ($doc['deadline'] < $today) {
	    $status = 'expired';
	    $status_color = $this->status->colors[$status];
	  }
	  elseif ($doc['deadline'] < $near) {
	    $status_color = $this->status->colors['near'];
	  }
	}

	switch($doc['priority']) {
	case 0:
	  $priority = lang('low');
	  $prio_color = '';
	  break;
	case 1:
	  $priority = lang('normal');
	  $prio_color = '#FFFFCC';
	  break;
	case 2:
	  $priority = lang('high');
	  $prio_color = '#FF9999';
	  break;
	default:
	  $priority = '&nbsp;';
	  $prio_color = '';
	}
	
	// last notified user
	$hist_info = $this->bo->get_last_history($doc['doc_id']);
	if ($hist_info == NULL) {
	  $lastuser = '--';
	}
	else {
	  if ($hist_info['user'] != 0) {
	    $lastuser = $GLOBALS['phpgw']->common->grab_owner_name($hist_info['user']);
	  } else {
	    $lastuser = '--';
	  }
	}

	$var = array(
		     'row_from' => (!$doc['doc_from']?'&nbsp':$doc['doc_from']),
		     'row_to' => (!$doc['doc_to']?'&nbsp':$doc['doc_to']),
		     'row_protocol' => '<a href="'.$GLOBALS['phpgw']->link('/index.php',Array('menuaction' => 'correspondence.uicorrespondence.view','doc_id' => $doc['doc_id'])) .'"> '.$doc['protocol'].' </a>',
		     'row_date'  => $this->date2string($doc['startdate']),
		     'row_owner' => $GLOBALS['phpgw']->common->grab_owner_name($doc['owner']),
		     'row_lastuser' => $lastuser,
		     'row_subject'  => (!$doc['subject']?'&nbsp':$doc['subject']),
		     'row_status'  => lang($status),
		     'row_prio'  => $priority,
		     'prio_color'  => $prio_color,
		     'row_deadline'  => $this->date2string($doc['deadline']),
		     'status_color' => $status_color
		     );

	$tpl->set_var($var);

	if ($this->bo->check_perms($this->grants[$doc['owner']],PHPGW_ACL_EDIT)) {
	  $tpl->set_var('row_edit',$this->row_action('edit',$doc['doc_id']));
	}
	else {
	  $tpl->set_var('row_edit','&nbsp;');
	}

	$tpl->parse('rows','row',True);
      }
    }
    $tpl->pparse('out','list');
  }

  function searchview()
  {
    if(isset($_POST['start'])) {
      $start = intval($_POST['start']);
    }
    else {
      $start = 0;
    }

    if(isset($_POST['words'])) {
      $allwords = chop($_POST['words']);
    }

    if(isset($_POST['notwords'])) {
      $notwords = chop($_POST['notwords']);
    }

    if(isset($_POST['date'])) {
      $date = $_POST['date'];
      if ($date == 'custom') {
	if (isset($_POST['begindate'])) {
	  $begindate = $_POST['begindate'];
	  if ($begindate['str'] != '') {
	    $l_begin = $begindate;
	  }
	}
	if (isset($_POST['enddate'])) {
	  $enddate = $_POST['enddate'];
	  if ($enddate['str'] != '') {
	    $l_end = $enddate;
	  }
	}
      }
    }

    if(isset($_POST['deadline'])) {
      $deadline = $_POST['deadline'];
      if ($deadline == 'custom') {
	if (isset($_POST['begindl'])) {
	  $begindl = $_POST['begindl'];
	  if ($begindl['str'] != '') {
	    $l_begindl = $begindl;
	  }
	}
	if (isset($_POST['enddl'])) {
	  $enddl = $_POST['enddl'];
	  if ($enddl['str'] != '') {
	    $l_enddl = $enddl;
	  }
	}
      }
    }

    if(isset($_POST['category'])) {
      $category = $_POST['category'];
    }

    if(isset($_POST['status'])) {
      $status = $_POST['status'];
    }

    if(isset($_POST['owner'])) {
      $owner = $_POST['owner'];
    }

    if(isset($_GET['order'])) {
      $order = $_GET['order'];
    }
    else {
      $order = 'deadline';
    }

    if(isset($_GET['sort'])) {
      $sort = $_GET['sort'];
    }
    else {
      $sort = 'ASC';
    }

    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
    unset($GLOBALS['phpgw_info']['flags']['noappfooter']);

    $GLOBALS['phpgw_info']['flags']['app_header'] = lang('correspondence - search results');

    $GLOBALS['phpgw']->common->phpgw_header();

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file(array('docs_t' => 'list.tpl'));

    $tpl->set_block('docs_t','list','list');
    $tpl->set_block('docs_t','row','row');
    $tpl->set_block('docs_t','row_empty','row_empty');
    
    $docs_info = $this->bo->get_adv_search($start,$sort,$order,$allwords,$notwords,$date,$l_begin,$l_end,$deadline,$l_begindl,$l_enddl,$category,$owner,$status);
    $total = $this->bo->total;
    
    $url = $GLOBALS['phpgw']->link('/index.php','menuaction=correspondence.uicorrespondence.searchview');

    $advquery = Array(
		      'menuaction' => 'correspondence.uicorrespondence.searchview',
		      'words' => $allwords,
		      'notwords' => $notwords,
		      'date' => $date,
		      'begindate' => $l_begin,
		      'enddate' => $l_end,
		      'deadline' => $deadline,
		      'begindead' => $l_begindl,
		      'enddead' => $l_enddl,
		      'status' => $status
		      );

    $var = Array(
		 'bg_color' => $this->theme['bg_color'],
		 'th_bg'    => $this->theme['th_bg'],
		 'left_next_matchs'   => $this->nextmatchs->left($url,$start,$total,$advquery),
		 'lang_documents' => $total?lang('%1 - %2 of %3 correspondences',$start+1,$start+count($docs_info),$total):'&nbsp;',
		 'right_next_matchs'  => $this->nextmatchs->right($url,$start,$total,$advquery),
		 'lang_edit'    => lang('edit'),
		 'actionurl'    => '',
		 'docs_url' => $url,
		 'lang_search'  => '',
		 'lang_owner' => lang('responsible'),
		 'lang_protocol' => lang('protocol number'),
		 'lang_subject' => lang('subject'),
		 'lang_date' => lang('insertion'),
		 'lang_deadline' => lang('deadline'),
		 'lang_from' => lang('from'),
		 'lang_to' => lang('to'),
		 'lang_status' => lang('status'),
		 'lang_priority' => lang('priority'),
		 'lang_lastuser' => lang('last user'),
		 'lang_edit'    => lang('edit'),
		 'input_add' => '',
		 'input_search' => ''
		 );

    $tpl->set_var($var);

    if (!count($docs_info) || !$total) {
      $tpl->set_var('message',lang('no matches found'));
      $tpl->parse('rows','row_empty',True);
    }
    else {
      $today = time();
      $near = $today + ($this->bo->prefs['correspondence']['near_days']*24*3600);

      while (list($null,$doc) = each($docs_info)) {
	$this->nextmatchs->template_alternate_row_color($tpl);
	
	$type = $this->types->id2name($doc['doc_type']);

	// status
	$status = $doc['status'];
	$status_color = $this->status->colors[$status];
	if ($status == 'pending') {
	  if ($doc['deadline'] < $today) {
	    $status = 'expired';
	    $status_color = $this->status->colors[$status];
	  }
	  elseif ($doc['deadline'] < $near) {
	    $status_color = $this->status->colors['near'];
	  }
	}

	switch($doc['priority']) {
	case 0:
	  $priority = lang('low');
	  $prio_color = '';
	  break;
	case 1:
	  $priority = lang('normal');
	  $prio_color = '#FFFFCC';
	  break;
	case 2:
	  $priority = lang('high');
	  $prio_color = '#FF9999';
	  break;
	default:
	  $priority = '&nbsp;';
	  $prio_color = '';
	}
	
	// last notified user
	$hist_info = $this->bo->get_last_history($doc['doc_id']);
	if ($hist_info == NULL) {
	  $lastuser = '--';
	}
	else {
	  if ($hist_info['user'] != 0) {
	    $lastuser = $GLOBALS['phpgw']->common->grab_owner_name($hist_info['user']);
	  } else {
	    $lastuser = '--';
	  }
	}

	$var = array(
		     'row_from' => (!$doc['doc_from']?'&nbsp':$doc['doc_from']),
		     'row_to' => (!$doc['doc_to']?'&nbsp':$doc['doc_to']),
		     'row_protocol' => '<a href="'.$GLOBALS['phpgw']->link('/index.php',Array('menuaction' => 'correspondence.uicorrespondence.view','doc_id' => $doc['doc_id'])) .'"> '.$doc['protocol'].' </a>',
		     'row_date'  => $this->date2string($doc['startdate']),
		     'row_owner' => $GLOBALS['phpgw']->common->grab_owner_name($doc['owner']),
		     'row_lastuser' => $lastuser,
		     'row_subject'  => (!$doc['subject']?'&nbsp':$doc['subject']),
		     'row_status'  => lang($status),
		     'row_prio'  => $priority,
		     'prio_color'  => $prio_color,
		     'row_deadline'  => $this->date2string($doc['deadline']),
		     'status_color' => $status_color
		     );

	$tpl->set_var($var);

	if ($this->bo->check_perms($this->grants[$doc['owner']],PHPGW_ACL_EDIT)) {
	  $tpl->set_var('row_edit',$this->row_action('edit',$doc['doc_id']));
	}
	else {
	  $tpl->set_var('row_edit','&nbsp;');
	}

	$tpl->parse('rows','row',True);
      }
    }
    $tpl->pparse('out','list');
  }
  
  function header()
  {
    $action = $GLOBALS['HTTP_GET_VARS']['menuaction'];
    $refer = explode('.',$action);
    $referrer = $refer[2];

    if ($referrer != 'listview') {
      return False;
    }

    $tpl = $GLOBALS['phpgw']->template;
    
    $template = Array(
		 'head_tpl'      => 'head.tpl'
		 );
    
    $tpl->set_file($template);
    $tpl->set_block('head_tpl','head','head');
    $tpl->set_block('head_tpl','head_table','head_table');
    $tpl->set_block('head_tpl','head_col','head_col');
    $tpl->set_block('head_tpl','form_dropdown','form_dropdown');

    $var = Array(
		 'form_width' => '28',
		 'form_link'     => $GLOBALS['phpgw']->link('/index.php','menuaction='.$action),
		 'form_name'     => 'cat_id',
		 'title' => lang('category'),
		 'hidden_vars'   => $base_hidden_vars,
		 'form_options'  => '<option value="0">'.lang('all').'</option>'.$this->cat->formated_list('select','all',$this->bo->cat_id,'True')
		 );
    
    $tpl->set_var($var);
    $tpl->set_var('str',$tpl->fp('out','form_dropdown'));
    $tpl->parse('header_column','head_col',True);
    
    $var = Array(
		 'form_width' => '28',
		 'form_link'     => $GLOBALS['phpgw']->link('/index.php','menuaction='.$action),
		 'form_name'     => 'filter',
		 'title' => lang('status'),
		 'hidden_vars'   => $base_hidden_vars,
		 'form_options'  => '<option value="0">'.lang('all').'</option>'.$this->status->formated_list($this->bo->filter)
		 );
    
    $tpl->set_var($var);
    $tpl->set_var('str',$tpl->fp('out','form_dropdown'));
    $tpl->parse('header_column','head_col',True);

    $dir_options = '<option value="R"'.($this->bo->direction=='R'?' selected':'').'>'.lang('input').'</option> <option value="S"'.($this->bo->direction=='S'?' selected':'').'>'.lang('output').'</option>';

    $var = Array(
		 'form_width' => '28',
		 'form_link'     => $GLOBALS['phpgw']->link('/index.php','menuaction='.$action),
		 'form_name'     => 'dir_id',
		 'title' => lang('direction'),
		 'hidden_vars'   => $base_hidden_vars,
		 'form_options'  => '<option value="0">'.lang('all').'</option>'.$dir_options
		 );
    
    $tpl->set_var($var);
    $tpl->set_var('str',$tpl->fp('out','form_dropdown'));
    $tpl->parse('header_column','head_col',True);

    $tpl->parse('row','head_table',True); 
    $tpl->pfp('out','head');
  }

  function search()
  {
    // before headers, because is javascript
    $jscal = CreateObject('phpgwapi.jscalendar');

    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
    unset($GLOBALS['phpgw_info']['flags']['noappfooter']);

    $GLOBALS['phpgw_info']['flags']['app_header'] = lang('correspondence - advanced search');

    $GLOBALS['phpgw']->common->phpgw_header();

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file(array('search_t' => 'search.tpl'));

    // date options
    $dateoptions = '  <option value="any"> '.lang('on any date').'</option>'."\n";
    $dateoptions .= '  <option value="week"> '.lang('on the last 7 days').'</option>'."\n";
    $dateoptions .= '  <option value="month"> '.lang('on the last 30 days').'</option>'."\n";
    $dateoptions .= '  <option value="month3"> '.lang('on the last 3 months').'</option>'."\n";
    $dateoptions .= '  <option value="year"> '.lang('on the last 12 months').'</option>'."\n";
    $dateoptions .= '  <option value="custom"> '.lang('between...').'</option>'."\n";

    // Users
    $accounts = $GLOBALS['phpgw']->acl->get_ids_for_location('run',1,'correspondence');
    $users = Array();
    for($i=0;$i<count($accounts);$i++) {
      $user = $accounts[$i];
      if(!isset($users[$user])) {
	$users[$user] = $GLOBALS['phpgw']->common->grab_owner_name($user);
        if($GLOBALS['phpgw']->accounts->get_type($user) == 'g') {
          $group_members = $GLOBALS['phpgw']->acl->get_ids_for_location($user,1,'phpgw_group');
          if($group_members != False) {
            for($j=0;$j<count($group_members);$j++) {
              if(!isset($users[$group_members[$j]])) {
                $users[$group_members[$j]] = $GLOBALS['phpgw']->common->grab_owner_name($group_members[$j]);
              }
            }
          }
        }
      }
    }
    
    $ownerstr = '    <option value="any"> '.lang('any').'</option>'."\n";
    @asort($users);
    @reset($users);
    while ($user = each($users)) {
      $ownerstr .= '    <option value="'.$user[0].'">('.$GLOBALS['phpgw']->accounts->get_type($user[0]).') '.$user[1].'</option>'."\n";
    }

    $var = Array(
		 'bg_color'       => $this->theme['th_bg'],
		 'tr_color1'      => $this->theme['row_on'],
		 'tr_color2'      => $this->theme['row_off'],
		 'action_url'     => $GLOBALS['phpgw']->link('/index.php','menuaction=correspondence.uicorrespondence.searchview'),
		 'lang_search'    => lang('search'),
		 'lang_protocol'  => lang('protocol number'),
		 'lang_subject'   => lang('subject'),
		 'lang_date'      => lang('created...'),
		 'lang_deadline'  => lang('deadline'),
		 'lang_from'      => lang('from'),
		 'lang_to'        => lang('to'),
		 'lang_status'    => lang('status'),
		 'lang_category'  => lang('category'),
		 'lang_lastuser'  => lang('last user'),
		 'lang_owner'     => lang('responsible'),
		 'lang_allwords'  => lang('with <b>all</b> words'),
		 'lang_except'    => lang('<b>without</b> words'),
		 'input_allwords' => '<input name="words" size="30" maxlength="80">',
		 'input_except'   => '<input name="notwords" size="30" maxlength="80">',
		 'input_date'     => '<select name="date">'."\n".$dateoptions.'   </select>',
		 'input_customdate' => $jscal->input('begindate[str]').' '.lang('and').' '.$jscal->input('enddate[str]'),
		 'input_deadline' => '<select name="deadline">'."\n".$dateoptions.'   </select>',
		 'input_status'   => '<select name="status">'."\n".'<option value="0" selected="selected">'.lang('all').'</option>'.$this->status->formated_list().'   </select>',
		 'input_customdeadline' => $jscal->input('begindead[str]').' '.lang('and').' '.$jscal->input('enddead[str]'),
		 'input_category' => '<select name="category">'.'<option value="0">'.lang('all').'</option>'.$this->cat->formated_list('select','all').'</select>',
		 'input_owner' => '<select name="owner">'."\n".$ownerstr.'   </select>',
		 'submit_button'   => lang('search'),
		 );

    $tpl->set_var($var);
    $tpl->pparse('out','search_t');
  }
}
?>
