<?php
 /**************************************************************************\
 * phpGroupWare - correspondence - doc. types                                          *
 * http://www.phpgroupware.org                                              *
 * -----------------------------------------------                          *
 *  This program is free software; you can redistribute it and/or modify it *
 *  under the terms of the GNU General Public License as published by the   *
 *  Free Software Foundation; either version 2 of the License, or (at your  *
 *  option) any later version.                                              *
 \**************************************************************************/

/* $Id: class.uitypes.inc.php,v 1.6 2005-09-21 22:07:12 andre Exp $ */

class uitypes
{
  var $doctypes;
  var $theme;

  var $public_functions = array(
				'add'  => True,
				'edit'  => True,
				'delete' => True,
				'admin' => True
				);

  function uitypes()
  {
    $this->doctypes = CreateObject('correspondence.types',1);
    $this->nextmatchs = createobject('phpgwapi.nextmatchs');

    $this->theme = $GLOBALS['phpgw_info']['theme'];
  }

  function add()
  {
    $this->create_edit(0);
  }

  function edit()
  {
    if(isset($_GET['type_id'])) {
      $_type_id = $_GET['type_id'];
    }
    else {
      $_type_id = 0;
    }
    
    $this->create_edit($_type_id);
  }

  function create_edit($_type_id)
  {
    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);

    $GLOBALS['phpgw_info']['flags']['app_header'] = $_type_id?lang('correspondence types - edit'):lang('correspondence types - add');

    $GLOBALS['phpgw']->common->phpgw_header();

    if($_type_id) {
      $userData = $this->doctypes->read_repository($_type_id);
    }
    else {
      $userData = Array();
    }

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file(array('edit_t' => 'edittyp.tpl'));

    $tpl->set_block('edit_t','form','form');
    $tpl->set_block('edit_t','form_button','form_button');

    if ($_type_id > 0) {
      $hidden = '<input type="hidden" name="type_id" value="'.$_type_id.'">';
    }

    $vars = Array(
		  'bg_color' => $this->theme['th_bg'],
		  'action_url' => $GLOBALS['phpgw']->link('/index.php',Array('menuaction'=>'correspondence.types.update')),
		  'errormsg'  => ($param['cd']?$GLOBALS['phpgw']->common->check_code($param['cd']):''),    
		  'tr_color1' => $this->theme['row_on'],
		  'tr_color2' => $this->theme['row_off'],
		  'lang_name' => lang('name'),
		  'lang_description' => lang('description'),
		  'type_name'  => '<input value="'.$userData['name'].'" name="name" size="10" maxlength="10">',
		  'type_description' => '<textarea name="description" rows="4" cols="40" wrap="virtual" maxlength="2048">'.$userData['description'].'</textarea>',
		  'submit_button' => lang('save'),
		  'common_hidden' => $hidden
		  );

    $tpl->set_var($vars);  

    $delete_button = $cancel_button = '';
    if ($_doc_id > 0) {
      $var = Array(
	   'action_url_button'     => $GLOBALS['phpgw']->link('/index.php',
			     Array('menuaction' => 'correspondence.uitypes.delete',
				   'doc_id' => $_doc_id )),
	   'action_text_button'    => lang('delete'),
	   'action_confirm_button' => "onClick=\"return confirm('".lang("are you sure you want to delete this entry?")."')\"",
	   'action_extra_field'    => ''
	   );
      $tpl->set_var($var);
      $delete_button = $tpl->fp('out','form_button');
    }
    $tpl->set_var('delete_button',$delete_button);

    if ($this->return_to) {
      $var = Array(
	   'action_url_button'     => $GLOBALS['phpgw']->link('/index.php','menuaction='.$this->return_to),
	   'action_text_button'    => lang('cancel'),
	   'action_confirm_button' => '',
	   'action_extra_field'    => ''
	   );
      $tpl->set_var($var);
      $cancel_button = $tpl->fp('out','form_button');
    }
    $tpl->set_var('cancel_button',$cancel_button);
       
    $tpl->pparse('out','form');
  }

  function delete()
  {
    if ($_POST['no'] || $_POST['yes'] || !@isset($_GET['type_id']) || !@$_GET['type_id']) {
      if ($_POST['yes']) {
	$this->doctypes->delete($_POST['type_id']);
      }
      $this->admin();
      return False;
    }

    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
    $GLOBALS['phpgw']->common->phpgw_header();

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file('del_t', 'delete.tpl');

    $tpl->set_block('del_t','form','form');
    $tpl->set_block('del_t','message_row','message_row');
    
    $tpl->set_var('message_display',
		  lang('are you sure you want to delete this entry?'));
    $tpl->parse('messages','message_row');

    $var = Array(
		 'form_action' => $GLOBALS['phpgw']->link('/index.php','menuaction=correspondence.uitypes.delete'),
		 'hidden_vars' => '<input type="hidden" name="type_id" value="'.$_GET['type_id'].'">',
		 'yes'         => lang('yes'),
		 'no'          => lang('no')
		 );
    $tpl->set_var($var);
    $tpl->pparse('phpgw_body','form');
  }

  function row_action($action,$type_id)
  {
    return '<a href="'.$GLOBALS['phpgw']->link('/index.php',
       Array('menuaction' => 'correspondence.uitypes.'.$action,
	     'type_id' => $type_id ))
       .'"> '.lang($action).' </a>';
  }

  function admin()
  {
    if(isset($_POST['start'])) {
      $start = intval($_POST['start']);
    }
    else {
      $start = 0;
    }
    
    if(isset($_GET['order'])) {
      $order = $_GET['order'];
    }
    else {
      $order = 'name';
    }

    if(isset($_GET['sort'])) {
      $sort = $_GET['sort'];
    }
    else {
      $sort = 'ASC';
    }

    unset($GLOBALS['phpgw_info']['flags']['noheader']);
    unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
    unset($GLOBALS['phpgw_info']['flags']['noappfooter']);

    $GLOBALS['phpgw_info']['flags']['app_header'] = lang('correspondence - types');

    $GLOBALS['phpgw']->common->phpgw_header();

    $tpl = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
    $tpl->set_file(array('types_t' => 'listtyp.tpl'));

    $tpl->set_block('types_t','list','list');
    $tpl->set_block('types_t','row','row');
    
    $types_info = $this->doctypes->get_list($start,$sort,$order);
    $total = $this->doctypes->total;

    $url = $GLOBALS['phpgw']->link('/index.php','menuaction=correspondence.uitypes.admin');

    $var = Array(
		 'bg_color' => $this->theme['bg_color'],
		 'th_bg'    => $this->theme['th_bg'],
		 'left_next_matchs'   => $this->nextmatchs->left($url,$start,$total,'menuaction=correspondence.uitypes.admin'),
		 'lang_types' => lang('showing %1',$start+count($types_info)),
		 'right_next_matchs'  => $this->nextmatchs->right($url,$start,$total,'menuaction=correspondence.uitypes.admin'),
		 'lang_edit'    => lang('edit'),
		 'lang_delete'  => lang('delete'),
		 'actionurl'    => $GLOBALS['phpgw']->link('/index.php','menuaction=correspondence.uitypes.add'),
		 'types_url' => $url,
		 'lang_name' => $this->nextmatchs->show_sort_order($sort,'name',$order,$url,lang('name')),
		 'lang_description' => $this->nextmatchs->show_sort_order($sort,'description',$order,$url,lang('description')),
		 'lang_edit'    => lang('edit'),
		 'lang_delete'  => lang('delete'),
		 'input_add' => '<input type="submit" value="' . lang('add') . '">'
		 );

    $tpl->set_var($var);

    if (!count($types_info) || !$total) {
      $tpl->set_var('rows','');
    }
    else {
      while (list($null,$typ) = each($types_info)) {
	$this->nextmatchs->template_alternate_row_color($tpl);
	
	$var = array(
		     'row_name'  => (!$typ['name']?'&nbsp':$typ['name']),
		     'row_description'  => (!$typ['description']?'&nbsp':$typ['description']),
		     'row_edit' => $this->row_action('edit',$typ['type_id']),
		     'row_delete' => $this->row_action('delete',$typ['type_id']),
		     );
	
	$tpl->set_var($var);
	$tpl->parse('rows','row',True);
      }
    }
    $tpl->pparse('out','list');
  }
}

?>
